package telnetdtest;

import net.wimpi.telnetd.*;
import net.wimpi.telnetd.io.*;
import net.wimpi.telnetd.net.*;
import net.wimpi.telnetd.shell.*;

public class Test1Shell implements Shell {

  //     
  // ().        
  // Shell,   ,   
  //     
  //   
  public static Shell createShell() {
    return new Test1Shell();
  }

  //  
  public void run(Connection con) {
    connection = con;
    termIO = (TerminalIO) connection.getTerminalIO();

    //      
    //  
    this.connection.addConnectionListener(this);

    //  ,    TelnetD
    termIO.write("TelnetD testbed 1"
      + CRLF + "TelnetD version: "
      + TelnetD.getReference().getVersion() + CRLF);
    termIO.flush();

    while (true) {
      //  
      termIO.write(CRLF
        + "Press [i] for information," + CRLF
        + "[x] for exit," + CRLF + "[s] for shutdown"
        + CRLF + CRLF);
      termIO.flush();

      //    
      int ch = termIO.read();

      //   
      switch (ch) {
        case 120: // x -  
          termIO.write("Goobye!"); 
          termIO.flush();
          connection.close();
          return;

        case 115: // s -  
          termIO.write("Requiescat in pace!"); 
          termIO.flush();
          TelnetD.getReference().setServing(false);
          TelnetD.getReference().shutdown();
          System.exit(0);
          return;

        case 105: // i -     
          //    
          ConnectionData data =
            connection.getConnectionData();

          //    
          termIO.write("Additional info:" + CRLF); 
          termIO.write("Connected from: "
            + data.getHostName()
            + " [" + data.getHostAddress() + ":"
            + data.getPort() + "]" + CRLF);
          termIO.write("Guessed locale: "
            + data.getLocale() + CRLF);
          termIO.write("Negotiated terminal type: "
            + data.getNegotiatedTerminalType() + CRLF);
          termIO.write("Scrolling support: "
            + (termIO.getTerminal().supportsScrolling() ?
              "yes" : "no") + CRLF);
          termIO.write("Graphics rendition support: "
            + (termIO.getTerminal().supportsSGR() ?
              "yes" : "no") + CRLF);
          termIO.write("Negotiated columns: "
            + data.getTerminalColumns() + CRLF);
          termIO.write("Negotiated rows: "
            + data.getTerminalRows() + CRLF);
          termIO.write("Login shell: "
            + data.getLoginShell() + CRLF); 
          termIO.flush();
          break;
      }
    }
  }

  //    : 
  public void connectionTimedOut(ConnectionEvent ce) {
    termIO.write("*** Connection timedout" + CRLF);
    termIO.flush();
    connection.close();
  }

  //    : 
  public void connectionIdle(ConnectionEvent ce) {
    termIO.write("*** Connection idle" + CRLF);
    termIO.flush();
  }

  //    :   
  //  (Ctrl+D)
  public void connectionLogoutRequest(ConnectionEvent ce) {
    termIO.write("*** Connection logout request" + CRLF);
    termIO.flush();
  }

  //    :  
  public void connectionBroken(ConnectionEvent ce) {
    termIO.write("*** Connection broken" + CRLF);
    termIO.flush();
  }

  //    :  NVT BREAK
  public void connectionSentBreak(ConnectionEvent ce) {
    termIO.write("*** Connection break" + CRLF);
    termIO.flush();
  }

  private Connection connection;
  private TerminalIO termIO;

  private final String CRLF = BasicTerminalIO.CRLF;

}
