package telnetdtest;

import net.wimpi.telnetd.*;
import net.wimpi.telnetd.io.*;
import net.wimpi.telnetd.net.*;
import net.wimpi.telnetd.shell.*;
import net.wimpi.telnetd.io.terminal.*;
import net.wimpi.telnetd.io.toolkit.*;

public class Test2Shell implements Shell {

  //     
  // ().        
  // Shell,   ,   
  //     
  //   
  public static Shell createShell() {
    return new Test2Shell();
  }

  //  
  public void run(Connection con) {
    connection = con;
    termIO = (TerminalIO) connection.getTerminalIO();

    //      
    //  
    this.connection.addConnectionListener(this);

    while (true) {
      //  
      termIO.eraseScreen();

      //       
      Titlebar title = new Titlebar(termIO, "");
      title.setTitleText("TelnetD testbed 2");
      title.setForegroundColor(ColorHelper.YELLOW);
      title.setBackgroundColor(ColorHelper.BLUE);
      title.setAlignment(Titlebar.ALIGN_CENTER);
      title.draw();
      Statusbar status = new Statusbar(termIO, "");
      status.setStatusText("TelnetD version: "
        + TelnetD.getReference().getVersion());
      status.setForegroundColor(ColorHelper.YELLOW);
      status.setBackgroundColor(ColorHelper.BLUE);
      status.setAlignment(Statusbar.ALIGN_RIGHT);
      status.draw();

      //    
      termIO.homeCursor();
      termIO.moveCursor(BasicTerminalIO.DOWN, 5);
      termIO.write(CRLF + "Use arrow keys to select "
        + "command, [Enter] or [Tab] to run command"
        + CRLF + "Command:" + CRLF);
      termIO.flush();

      //      
      Selection menu = new Selection(termIO, "");
      menu.addOption("Editfield demo");
      menu.addOption("Editarea demo");
      menu.addOption("Exit");
      menu.addOption("Shutdown");
      menu.run();

      //   
      int cmd = menu.getSelected();

      //   
      switch (cmd) {
        case 0: //  
                //  
          termIO.eraseScreen();
          termIO.homeCursor();
          termIO.write("Editfield demo" + CRLF
            + "--------------" + CRLF);

          final int MAX_EDITFIELD_CHARS = 20;

          //    
          termIO.write(CRLF + "Type any text (max "
            + MAX_EDITFIELD_CHARS + " chars), press "
            + "[Enter] or [Tab] to finish typing"
            + CRLF + "Text:" + CRLF);
          termIO.flush();

          //   
          Editfield editfield = new Editfield(termIO,
            "", MAX_EDITFIELD_CHARS);

          //    
          editfield.run();

          //   
          termIO.write(CRLF + "Your input: " + CRLF
            + editfield.getValue() + CRLF); 
          termIO.flush();
          
          break;

        case 1: //  
                //  
          termIO.eraseScreen();
          termIO.homeCursor();
          termIO.write("Editarea demo" + CRLF
            + "-------------" + CRLF);

          final int MAX_EDITAREA_ROWS = 4;

          //    
          termIO.write(CRLF + "Type any text (max "
            + MAX_EDITAREA_ROWS + " rows), press [Tab] "
            + "to finish typing" + CRLF + "Text:" + CRLF);
          termIO.flush();

          //   
          Editarea editarea = new Editarea(termIO, "",
            MAX_EDITAREA_ROWS, MAX_EDITAREA_ROWS);

          //    
          editarea.run();

          //   
          termIO.write(CRLF + "Your input: " + CRLF
            + editarea.getValue() + CRLF); 
          termIO.flush();
          
          break;

        case 2: //  
          connection.close();
          return;

        case 3: //  
          TelnetD.getReference().setServing(false);
          TelnetD.getReference().shutdown();
          System.exit(0);
          return;
      }

      // ,     
      termIO.write(CRLF + "Press any key"); 
      termIO.flush();
      termIO.read();
    }
  }

  //    : 
  public void connectionTimedOut(ConnectionEvent ce) {
    termIO.write("*** Connection timedout" + CRLF);
    termIO.flush();
    connection.close();
  }

  //    : 
  public void connectionIdle(ConnectionEvent ce) {
    termIO.write("*** Connection idle" + CRLF);
    termIO.flush();
  }

  //    :   
  //  (Ctrl+D)
  public void connectionLogoutRequest(ConnectionEvent ce) {
    termIO.write("*** Connection logout request" + CRLF);
    termIO.flush();
  }

  //    :  
  public void connectionBroken(ConnectionEvent ce) {
    termIO.write("*** Connection broken" + CRLF);
    termIO.flush();
  }

  //    :  NVT BREAK
  public void connectionSentBreak(ConnectionEvent ce) {
    termIO.write("*** Connection break" + CRLF);
    termIO.flush();
  }

  private Connection connection;
  private TerminalIO termIO;

  private final String CRLF = BasicTerminalIO.CRLF;

}
